/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.bussines.interfaces;

import java.util.Collection;

import javax.ejb.Remote;
import javax.persistence.PersistenceException;

import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;
import edu.uoc.eAquarium.integration.Aquarium.AquariumJPA;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;
import edu.uoc.eAquarium.integration.Order.OrderJPA;
import edu.uoc.eAquarium.integration.User.UserJPA;
import edu.uoc.eAquarium.integration.User.UserRegisteredJPA;

/**
 * Session EJB Remote Interfaces
 */
@Remote
public interface CategoryFacadeRemote {
	  /**
	   * Remotely invoked method.
	   */
	  //Gestin de peces exticos
	  public void addCategoryAgenda(ExoticFishJPA categoryAgendaJPA);
	  public java.util.Collection<ExoticFishJPA> listAllCategoriesAgenda();
	  public ExoticFishJPA showCategory(long categoryId) throws PersistenceException;
	  public void modifyCategoryAgenda(ExoticFishJPA categoryAgendaJPA);
	  public void removeExoticFish(ExoticFishJPA exoticFish) throws PersistenceException;
	  public void addOrderToUser(OrderJPA orderJPA) throws PersistenceException;
	  
	  //Gestin de acuarios
	  public void addAquarium(AquariumJPA aquariumJPA);
	  public java.util.Collection<AquariumJPA> listAllAquariums();
	  public AquariumJPA showAquarium(long aquariumId) throws PersistenceException;
	  public void modifyAquarium(AquariumJPA aquariumJPA);
	  public void removeAquarium(AquariumJPA aquariumJPA);
	  
	  //Gestin de accesorios
	  public void addAccessory(AccessoryJPA accessoryJPA);
	  public java.util.Collection<AccessoryJPA> listAllAccesories();
	  public AccessoryJPA showAccessory(long accessoryId) throws PersistenceException;
	  public void modifyAccessory(AccessoryJPA accessoryJPA);
	  public void removeAccesory(AccessoryJPA accessoryJPA) throws PersistenceException;;
	  
	  //Gestin de usuarios
	  public void addRegisteredUser(UserRegisteredJPA userJPA);
	  public void addUserIni(UserJPA userJPA);	
	  public UserJPA showUser(String  login, String password) throws PersistenceException;
	  public UserJPA showUserByLogin(String login) throws PersistenceException;
	 public Collection<OrderJPA> listAllOrdersUser(String loginUser) throws PersistenceException;
	
	 //Orders
	 public Collection<OrderJPA> listOrdersByProduct(long idProduct)throws PersistenceException;
	


}
