/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.integration.Order;
import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;
import edu.uoc.eAquarium.integration.Aquarium.AquariumJPA;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;
import edu.uoc.eAquarium.integration.User.UserJPA;

/**
 * JPA Class UserAdministrationJPA
 */
@Entity
@Table(name="tfcaquarium.orders")
public class OrderJPA implements Serializable {
 
	private static final long serialVersionUID = 1L;
	
	 @Id
	 @GeneratedValue
	 @Column(name="ID_PEDIDO")
	 private long idPedido;
	
	 @ManyToOne(fetch=FetchType.EAGER,optional=true)
	 @JoinColumn(name="ID_EXOTICFISH", nullable=true)
	 private ExoticFishJPA exoticFishJPA;
	 
	 @ManyToOne(fetch=FetchType.EAGER,optional=true)
	 @JoinColumn(name="ID_AQUARIUM", nullable=true)
	 private AquariumJPA aquariumJPA;
	 
	 @ManyToOne(fetch=FetchType.EAGER,optional=true)
	 @JoinColumn(name="ID_ACCESSORY", nullable=true)
	 private AccessoryJPA accessoryJPA;
	 
	 @ManyToOne(fetch=FetchType.EAGER,optional=false)
	 @JoinColumn(name="ID_USER")
	 private UserJPA userJPA;
	
	 private Date fechaPedido;
	 
	 private Date fechaEntrega;
	 
	

	public UserJPA getUserJPA() {
		return userJPA;
	}

	public void setUserJPA(UserJPA userJPA) {
		this.userJPA = userJPA;
	}

	public ExoticFishJPA getExoticFishJPA() {
		return exoticFishJPA;
	}

	public void setExoticFishJPA(ExoticFishJPA exoticFishJPA) {
		this.exoticFishJPA = exoticFishJPA;
	}

	public AquariumJPA getAquariumJPA() {
		return aquariumJPA;
	}

	public void setAquariumJPA(AquariumJPA aquariumJPA) {
		this.aquariumJPA = aquariumJPA;
	}

	public AccessoryJPA getAccessoryJPA() {
		return accessoryJPA;
	}

	public void setAccessoryJPA(AccessoryJPA accessoryJPA) {
		this.accessoryJPA = accessoryJPA;
	}

	public long getIdPedido() {
		return idPedido;
	}

	public void setIdPedido(long idPedido) {
		this.idPedido = idPedido;
	}


	public Date getFechaPedido() {
		return fechaPedido;
	}

	public void setFechaPedido(Date fechaPedido) {
		this.fechaPedido = fechaPedido;
	}

	public Date getFechaEntrega() {
		return fechaEntrega;
	}

	public void setFechaEntrega(Date fechaEntrega) {
		this.fechaEntrega = fechaEntrega;
	}

	
	
}
