/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.integration.User;
import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import edu.uoc.eAquarium.integration.Perfil.PerfilJPA;

/**
 * JPA Class UserAdministrationJPA
 */
@Entity
@Table(name="tfcaquarium.users")
@Inheritance(strategy=InheritanceType.SINGLE_TABLE) 
@DiscriminatorColumn(name = "USER_TYPE")
public abstract class UserJPA implements Serializable {
 
	private static final long serialVersionUID = 1L;
	
	 @Id
	 @Column(name="LOGIN")
	 private String login;
	 
	 private String password;
	
	 @ManyToOne(fetch=FetchType.EAGER,optional=false)
	 @JoinColumn(name="ID_PERFIL")
	 private PerfilJPA perfil;
	
	 private String name;
	 
	 private String surname;
	 
	public UserJPA() {
		super();
	}

	public String getLogin() {
		return login;
	}
	
	public void setLogin(String login) {
		this.login = login;
	}
	
	public String getPassword() {
		return password;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}
	
	public PerfilJPA getPerfil() {
		return perfil;
	}
	
	public void setPerfil(PerfilJPA perfil) {
		this.perfil = perfil;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getSurname() {
		return surname;
	}

	public void setSurname(String surname) {
		this.surname = surname;
	}

	
	
}
