/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.AddAccessory;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;


/**
 * Managed Bean AddAccessoryMBean
 */
@ManagedBean(name = "addAccessory")
@SessionScoped
public class AddAccessoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote addCategoryRemote;
	//stores CategoryAgendaJPA instance
	protected AccessoryJPA dataAccessory;
	//stores CategoryJPA number id
	protected String idCategory = "0";
	
	private UploadedFile urlImage;
	
	public AddAccessoryMBean() {
		super();
		dataAccessory = new AccessoryJPA();
		setDataAccessory(dataAccessory);
	}

	
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		return urlImage;
	}


	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}


	public String getIdCategory()
	{
		return idCategory;
	}
	
	public AccessoryJPA getDataAccessory()
	{
		System.out.println("Entra en el alta de accesorios");
		return dataAccessory;
	}	
	
	
	/**
	 * @param dataCategory the dataCategory to set
	 */
	public void setDataAccessory(AccessoryJPA dataAccessory) {
		this.dataAccessory = dataAccessory;
	}

	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String showAddAccessory() throws Exception {
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
//		CategoryAgendaJPA categoryAgendaJPA = new CategoryAgendaJPA();
//		categoryAgendaJPA.setId("1");
//		categoryAgendaJPA.setName("Fiesta en casa");
//		categoryAgendaJPA.setDescription("Fiestuki en casa de Fran");
//		
//		addCategoryRemote.addCategoryAgenda(categoryAgendaJPA);
		
		return "modifyAccessoryView";
	
	}
	
	/**
	 * Method that gets a list of instances by category or all CategoryJPA
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public String addAccessory() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		if (addCategoryRemote.showAquarium(dataAccessory.getId()) == null) {
			AccessoryJPA accessoryJPA = new AccessoryJPA();
			accessoryJPA.setId(dataAccessory.getId());
			accessoryJPA.setName(dataAccessory.getName());
			accessoryJPA.setDescription(dataAccessory.getDescription());
			accessoryJPA.setDescription(dataAccessory.getDescription());
			accessoryJPA.setPrice(dataAccessory.getPrice());
			
			if(urlImage != null) {
				System.out.println("URL image: "+	getUrlImage().getFileName());
				System.out.println("Tipo: "+	getUrlImage().getContentType());
				System.out.println("URL image: "+	getUrlImage().getSize());
				 
				 
				 File someFile = File.createTempFile("tempfileAccessory", ".tmp"); 
				 if(!someFile.exists()) {
					 someFile.createNewFile();
				 }
			        FileOutputStream fos = new FileOutputStream(someFile);
			        fos.write(getUrlImage().getContents());
			        fos.flush();
			        fos.close();
				    
				    
			        accessoryJPA.setImage(getUrlImage().getContents());
			}
			
			System.out.print("id:" + dataAccessory.getId());
			System.out.print("name:" +dataAccessory.getName());
			System.out.print("descripcion:" + dataAccessory.getDescription());
			
			addCategoryRemote.addAccessory(accessoryJPA);
			
			setDataAccessory(null);
			
			dataAccessory = new AccessoryJPA();
			
			setDataAccessory(dataAccessory);
			
			urlImage = null;
			
		} else {
			  FacesMessage message = new FacesMessage("No se puede dar de alta el accesorio con id: "+ dataAccessory.getId() + " "
			  		+ "ya que actualmente existe.");
	            FacesContext context = FacesContext.getCurrentInstance();
	            context.addMessage("Error duplicado",message);
			
			return null;
		}
		
		return "AccessoryListView";
		
	}
	
}
