/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.AddAquarium;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Aquarium.AquariumJPA;


/**
 * Managed Bean AddCategoryMBean
 */
@ManagedBean(name = "addAquarium")
@SessionScoped
public class AddAquariumMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote addCategoryRemote;
	//stores CategoryAgendaJPA instance
	protected AquariumJPA dataAquarium;
	//stores CategoryJPA number id
	protected String idCategory = "0";
	
	private UploadedFile urlImage;
	
	public AddAquariumMBean() {
		super();
		dataAquarium = new AquariumJPA();
		setDataAquarium(dataAquarium);
	}

	
	
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		return urlImage;
	}



	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}



	/**
	 * Get/set the id number and AquariumJPA instance
	 * @return AquariumJPA Id
	 */
	public String getIdCategory()
	{
		return idCategory;
	}
	
	public AquariumJPA getDataAquarium()
	{
		System.out.println("Entra en el alta de categorias");
		return dataAquarium;
	}	
	
	
	/**
	 * @param dataCategory the dataCategory to set
	 */
	public void setDataAquarium(AquariumJPA dataAquarium) {
		this.dataAquarium = dataAquarium;
	}

	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String showAddAquarium() throws Exception {
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
//		CategoryAgendaJPA categoryAgendaJPA = new CategoryAgendaJPA();
//		categoryAgendaJPA.setId("1");
//		categoryAgendaJPA.setName("Fiesta en casa");
//		categoryAgendaJPA.setDescription("Fiestuki en casa de Fran");
//		
//		addCategoryRemote.addCategoryAgenda(categoryAgendaJPA);
		
		return "modifyAquariumView";
	
	}
	
	/**
	 * Method that gets a list of instances by category or all CategoryJPA
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public String addAquarium() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		if (addCategoryRemote.showAquarium(dataAquarium.getId()) == null) {
			AquariumJPA aquariumJPA = new AquariumJPA();
			aquariumJPA.setId(dataAquarium.getId());
			aquariumJPA.setName(dataAquarium.getName());
			aquariumJPA.setDescription(dataAquarium.getDescription());
			aquariumJPA.setDimensionAlt(dataAquarium.getDimensionAlt());
			aquariumJPA.setDimensionAncho(dataAquarium.getDimensionAncho());
			aquariumJPA.setDimensionLargo(dataAquarium.getDimensionLargo());
			aquariumJPA.setPrecio(dataAquarium.getPrecio());
			
			if(urlImage != null) {
				System.out.println("URL image: "+	getUrlImage().getFileName());
				System.out.println("Tipo: "+	getUrlImage().getContentType());
				System.out.println("URL image: "+	getUrlImage().getSize());
				 
				 
				File someFile = File.createTempFile("tempfileAquarium", ".tmp"); 
				
				 if(!someFile.exists()) {
					 someFile.createNewFile();
				 }
			        FileOutputStream fos = new FileOutputStream(someFile);
			        fos.write(getUrlImage().getContents());
			        fos.flush();
			        fos.close();
				    
				    
			        aquariumJPA.setImage(getUrlImage().getContents());
			}
			
			System.out.print("id:" + dataAquarium.getId());
			System.out.print("name:" +dataAquarium.getName());
			System.out.print("descripcion:" + dataAquarium.getDescription());
			
			addCategoryRemote.addAquarium(aquariumJPA);
			
			setDataAquarium(null);
			
			dataAquarium = new AquariumJPA();
			
			setDataAquarium(dataAquarium);
			
			urlImage = null;
			
		} else {
			  FacesMessage message = new FacesMessage("No se puede dar de alta la categora con id: "+ dataAquarium.getId() + " "
			  		+ "ya que actualmente existe.");
	            FacesContext context = FacesContext.getCurrentInstance();
	            context.addMessage("Error duplicado",message);
			
			return null;
		}
		
		return "AquariumListView";
		
	}
	
}
