/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.AddCategory;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;

/**
 * Managed Bean AddCategoryMBean
 */
@ManagedBean(name = "addCategoryAgenda")
@SessionScoped
public class AddCategoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote addCategoryRemote;
	//stores CategoryAgendaJPA instance
	protected ExoticFishJPA dataCategory;
	//stores CategoryJPA number id
	protected String idCategory = "0";
	
	private UploadedFile urlImage;
	
	public AddCategoryMBean() {
		super();
		dataCategory = new ExoticFishJPA();
		setDataCategory(dataCategory);
	}

	
	
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		System.out.print("getImage:"+ urlImage);
		return urlImage;
	}



	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}



	/**
	 * Get/set the id number and ExoticFish instance
	 * @return ExoticFish Id
	 */
	public String getIdCategory()
	{
		return idCategory;
	}
	
	public ExoticFishJPA getDataCategory()
	{
		System.out.println("Entra en el alta de categorias");
		return dataCategory;
	}	
	
	
	/**
	 * @param dataCategory the dataCategory to set
	 */
	public void setDataCategory(ExoticFishJPA dataCategory) {
		this.dataCategory = dataCategory;
	}

	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String showAddCategory() throws Exception {
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
//		CategoryAgendaJPA categoryAgendaJPA = new CategoryAgendaJPA();
//		categoryAgendaJPA.setId("1");
//		categoryAgendaJPA.setName("Fiesta en casa");
//		categoryAgendaJPA.setDescription("Fiestuki en casa de Fran");
//		
//		addCategoryRemote.addCategoryAgenda(categoryAgendaJPA);
		
		return "modifyCategoryView";
	
	}
	
	/**
	 * Method that gets a list of instances by category or all CategoryJPA
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public String addCategory() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		if (addCategoryRemote.showCategory(dataCategory.getIdFish()) == null) {
			ExoticFishJPA categoryAgendaJPA = new ExoticFishJPA();
			categoryAgendaJPA.setIdFish(dataCategory.getIdFish());
			categoryAgendaJPA.setName(dataCategory.getName());
			categoryAgendaJPA.setScientificName(dataCategory.getScientificName());
			
	System.out.print("URLIMAGE:"+ getUrlImage());
			if(urlImage != null) {
				System.out.println("URL image: "+	getUrlImage().getFileName());
				System.out.println("Tipo: "+	getUrlImage().getContentType());
				System.out.println("URL image: "+	getUrlImage().getSize());
				 
//				 File someFile = new File("C:\\"+getUrlImage().getFileName());
				    File someFile = File.createTempFile("tempfileCategory", ".tmp"); 
				 if(!someFile.exists()) {
					 someFile.createNewFile();
				 }
			        FileOutputStream fos = new FileOutputStream(someFile);
			        fos.write(getUrlImage().getContents());
			        fos.flush();
			        fos.close();
				    
				    
				categoryAgendaJPA.setImage(getUrlImage().getContents());
			}
			categoryAgendaJPA.setPrice(dataCategory.getPrice());
			categoryAgendaJPA.setPlace(dataCategory.getPlace());
			System.out.print("id:" + dataCategory.getIdFish());
			System.out.print("name:" +dataCategory.getName());
			System.out.print("descripcion:" + dataCategory.getScientificName());
			
			addCategoryRemote.addCategoryAgenda(categoryAgendaJPA);
			
			setDataCategory(null);
			
			dataCategory = new ExoticFishJPA();
			
			setDataCategory(dataCategory);
			
			urlImage = null;
			
		} else {
			  FacesMessage message = new FacesMessage("No se puede dar de alta la categora con id: "+ dataCategory.getIdFish() + " "
			  		+ "ya que actualmente existe.");
	            FacesContext context = FacesContext.getCurrentInstance();
	            context.addMessage("Error duplicado",message);
			
			return null;
		}
		
		return "CategoryListView";
		
	}
	
}
