/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.AddUser;

import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;
import edu.uoc.eAquarium.integration.Perfil.PerfilJPA;
import edu.uoc.eAquarium.integration.User.UserAdministrationJPA;
import edu.uoc.eAquarium.integration.User.UserJPA;
import edu.uoc.eAquarium.integration.User.UserRegisteredJPA;


/**
 * Managed Bean AddCategoryMBean
 */
@ManagedBean(name = "addUser")
@SessionScoped
public class AddUserMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote addUserRemote;
	//stores CategoryAgendaJPA instance
	protected UserRegisteredJPA dataUser;
	//stores CategoryJPA number id
	protected String idCategory = "0";
	
	
	public AddUserMBean() {
		super();
		dataUser = new UserRegisteredJPA();
		setDataUSer(dataUser);
	}

	/**
	 * Get/set the id number and UserJPA instance
	 * @return UserJPA Id
	 */
	public String getIdCategory()
	{
		return idCategory;
	}
	
	public UserRegisteredJPA getDataUser()
	{
	
		return dataUser;
	}	
	
	
	/**
	 * @param dataCategory the dataCategory to set
	 */
	public void setDataUSer(UserRegisteredJPA dataUser2) {
		this.dataUser = dataUser2;
	}

	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String showAddAquarium() throws Exception {
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addUserRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");

		return "modifyAquariumView";
	
	}
	
	/**
	 * Method that gets a list of instances by category or all CategoryJPA
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public String addUser() throws Exception {	
		
	            
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		addUserRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		UserRegisteredJPA userJPA;
		if (addUserRemote.showUserByLogin(dataUser.getLogin()) == null) {
//			UserJPA user = new UserJPA();
			System.out.println("Entra para registrar a un usuario");
			 userJPA = new UserRegisteredJPA();
			
			//Introducimos le perfil de registro =2 ,el de administrador sera el 1
			PerfilJPA perfilJPA = new PerfilJPA();
			perfilJPA.setId("2");
		
			userJPA.setLogin(dataUser.getLogin());
			userJPA.setPassword(dataUser.getPassword());
			userJPA.setEmail(dataUser.getEmail());
			userJPA.setAddress(dataUser.getAddress());
			userJPA.setName(dataUser.getName());
			userJPA.setSurname(dataUser.getSurname());
			userJPA.setPerfil(perfilJPA);
		
			System.out.print("id:" + dataUser.getLogin());
			System.out.print("password:" +dataUser.getPassword());
			System.out.print("Email:" + dataUser.getEmail());
			System.out.print("Direccin:" +dataUser.getAddress());
			System.out.print("Apellido:" + dataUser.getSurname());
			
			
//			addUserRemote.addUserIni(user);
			addUserRemote.addRegisteredUser(userJPA);
			
			setDataUSer(null);
			
			dataUser = new UserRegisteredJPA();
			
			setDataUSer(dataUser);
		} else {
			System.out.println("EL usuario " +dataUser.getLogin() +"  que desea registrar ya existe, por favor introduzca otro login.");
			  FacesMessage message = new FacesMessage("EL usuario " +dataUser.getLogin() +"  que desea registrar ya existe, por favor introduzca otro login.");
	            FacesContext context = FacesContext.getCurrentInstance();
	            context.addMessage("Error duplicado",message);
			
			return "AddUserView";
		}
		
		  FacesMessage message = new FacesMessage("Se ha dado de alta el usuario con login: "+ userJPA.getLogin() + " "
			  		+ ". Por favor, ingrese en su cuenta para poder realizar pedidos y/o consultar su lista de pedidos..");
	            FacesContext context = FacesContext.getCurrentInstance();
	            context.addMessage("INFO:",message);
			
		return "AddUserView";
		
	}
	

	public String volver() throws Exception {
		dataUser = new UserRegisteredJPA();

		return "homeView";
	}
	
}
