/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ListOrders;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.naming.Context;
import javax.naming.InitialContext;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Order.OrderJPA;


/**
 * Managed Bean ListCategoriesMBean
 */
@ManagedBean(name = "listOrdersUser")
@SessionScoped
public class ListOrdersMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;	

	@EJB
	private CategoryFacadeRemote ordersRemote;

	protected OrderJPA dataOrder;
	//stores the screen number where the user is 
	private int screen = 0;
	
	//stores ten or fewer ListOrdersMBean instances that the user can see on a screen
	protected Collection<OrderJPA> ordersList;
			
	//stores ten or fewer ListOrdersMBean instances that the user can see on a screen
	protected Collection<OrderJPA> ordersListView;
	
	protected String loginUser;

	protected String idPedido;
	
	protected int numberlistCategories = 0;
	
	
	
	/**
	 * @return the idPedido
	 */
	public String getIdPedido() {
		return idPedido;
	}



	/**
	 * @param idPedido the idPedido to set
	 */
	public void setIdPedido(String idPedido) {
		this.idPedido = idPedido;
	}



	public String getLoginUser() {
		System.out.print("Entra en pedidos para usuario: "+loginUser);
		
		return loginUser;
	}



	public void setLoginUser(String loginUser) {
		
		this.loginUser = loginUser;
		
		System.out.println("Login user conectado:"+ loginUser);
		
	}


	/**
	 * @return the dataOrder
	 */
	public OrderJPA getDataOrder() {
		return dataOrder;
	}



	/**
	 * @param dataOrder the dataOrder to set
	 */
	public void setDataOrder(OrderJPA dataOrder) {
		this.dataOrder = dataOrder;
	}



	/**
	 * Method that calculates the name of the category after analyzing where the user has
	 * clicked the mouse.
	 */
	public void ordersMap(ActionEvent e) {
		FacesContext context = FacesContext.getCurrentInstance();
		String orderId = e.getComponent().getClientId(context);
		@SuppressWarnings("rawtypes")
		Map requestParams = context.getExternalContext().getRequestParameterMap();
		
		int x = new Integer((String) requestParams.get(orderId + ".x")).intValue();
		int y = new Integer((String) requestParams.get(orderId + ".y")).intValue();	
		
	}


	
	/**
	 * Method that returns an instance Collection of 10 or less OrderJPA according screen 
	 * where the user is.
	 * @return Collection OrderJPA
	 * @throws Exception 
	 */
	public Collection<OrderJPA> getOrdersListView() throws Exception {
	 
		ordersList();
		 
		int n =0;
		ordersListView = new ArrayList<OrderJPA>();
		for (Iterator<OrderJPA> iter2 = ordersList.iterator(); iter2.hasNext();)
		{
			OrderJPA cat2 = (OrderJPA) iter2.next();
			if (n >= screen*20 && n< (screen*20+20))
			{				
				this.ordersListView.add(cat2);
			}
			n +=1;
		}
		this.numberlistCategories = n;
		return ordersListView;
	}
	
	/**
	 * Returns the total number of instances of AccessoryJPA
	 * @return AccessoryJPA number
	 */
	public int getNumberlistCategories()
	{ 
		return this.numberlistCategories;
	}
	
	/**
	 * allows forward or backward in user screens
	 */
	public void nextScreen()
	{
		if (((screen+1)*10 < ordersList.size()))
		{
			screen +=1;
		}
	}
	public void previousScreen()
	{
		if ((screen > 0))
		{
			screen -=1;
		}
	}
	
	
	public String listOrders() throws Exception { 
	
		System.out.println("Entra para listar los pedidos del usuario: "+ getLoginUser());
		ordersList();
		System.out.println("Finaliza correctamente el listaod de pedidos.");
		return "OrdersListView";
	}

	
	/**
	 * Method used for Facelet to call CategoryDetailView Facelet
	 * @return Facelet name
	 */
	public String setShowPet()
	{
		return "CategoryDetailView";
	}
	
	
	/**
	 * Method that gets a list of instances by category or all OrderJPA
	 * @param login 
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	private void ordersList() throws Exception {
		
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		screen = 0;
		
		Map params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();
		setLoginUser(params.get("userLogin") != null ? ((String)params.get("userLogin")):null);
		System.out.println("Listando pedidos para usuario: "+getLoginUser());
		
		System.out.println("Recupera listado de pedidos para login:"+ getLoginUser());
		ordersRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		 
			ordersList = (Collection<OrderJPA>)ordersRemote.listAllOrdersUser(getLoginUser());
	}

	/**
	 * Method that gets a list of orders by product 
	 * @param login 
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	private void findOrderByProduct(long idProduct) throws Exception {
		
		System.out.println("Busca para saber si existe un producto en concreto pedido.");
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		screen = 0;
		
//		Map params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();
//		setIdPedido(params.get("idProduct") != null ? ((String)params.get("idProduct")):null);
		System.out.println("Listando pedidos para el producto: "+ idProduct);
	
		ordersRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		 
			ordersList = (Collection<OrderJPA>)ordersRemote.listOrdersByProduct(idProduct);
	}
	
}
