/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ModifyAccessory;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;
import edu.uoc.eAquarium.integration.Order.OrderJPA;
import edu.uoc.eAquarium.integration.User.UserRegisteredJPA;


/**
 * Managed Bean modifyCategoryAgenda
 */
@ManagedBean(name = "modifyAccessory")
@SessionScoped
public class ModifyAccessoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote modifyAccesoryRemote;
	//stores CategoryAgendaJPA instance
	
	protected AccessoryJPA dataAccesory;
	//stores CategoryAgendaJPA instance
	protected AccessoryJPA dataAccessoryInsert;
	
	//stores AccessoryJPA number id
	protected long idCategory = 0;
	
	protected String loginUser = "";
	
	private UploadedFile urlImage;
	
	
	
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		return urlImage;
	}
	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}
	/**
	 * @return the loginUser
	 */
	public String getLoginUser() {
		return loginUser;
	}
	/**
	 * @param loginUser the loginUser to set
	 */
	public void setLoginUser(String loginUser) {
		this.loginUser = loginUser;
	}
	public ModifyAccessoryMBean() {
		super();
		dataAccesory = new AccessoryJPA();
	
	}
	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		
		if(dataAccesory != null && idCategory != 0) {
			setDataAccessory();
		}  
		System.out.println("idAccessory:"+ idCategory);
		
	}
	
	
	
	/**
	 * @return the dataPetCaategory
	 */
	public AccessoryJPA getDataAccessoryInsert() {
		return dataAccessoryInsert;
	}
	/**
	 * @param dataAccessoryInsert the dataCategoryInsert to set
	 */
	public void setDataAccessoryInsert(AccessoryJPA dataAccessoryInsert) {
		this.dataAccessoryInsert = dataAccessoryInsert;
	}
	public AccessoryJPA getDataAccessory() {
		return dataAccesory;
	}	
	
	public void setDataAccessory() throws Exception {
		
		
			Properties props = System.getProperties();
			Context ctx = new InitialContext(props);
			modifyAccesoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
			dataAccesory = (AccessoryJPA) modifyAccesoryRemote.showAccessory(idCategory);
			System.out.println("Entra en setDataAccessory :"+ dataAccesory.getName());
		
	}
	
	/**
	 * Get/set the id number and AccessoryJPA instance
	 * @return AccessoryJPA Id
	 */
	public long getIdCategory()
	{
		System.out.println("Entra alta :"+ idCategory);
		return idCategory;
	}

	public String volver() throws Exception {
		dataAccesory = new AccessoryJPA();
		setIdCategory(0);
		return "AccessoryListView";
	}
 
	/**
	 * Method that gets a list of instances by category or all AccessoryJPA
	 * @throws Exception
	 */

	@SuppressWarnings("unused")
	public String modifyAccessory() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyAccesoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AccessoryJPA accessoryJPA = new AccessoryJPA();
		accessoryJPA.setId(dataAccesory.getId());
		accessoryJPA.setName(dataAccesory.getName());
		accessoryJPA.setDescription(dataAccesory.getDescription());
		accessoryJPA.setDescription(dataAccesory.getDescription());
		accessoryJPA.setPrice(dataAccesory.getPrice());
		System.out.println("Nombre modificado:" +dataAccesory.getName());
		
		
		if(urlImage != null) {
			System.out.println("URL image: "+	getUrlImage().getFileName());
			System.out.println("Tipo: "+	getUrlImage().getContentType());
			System.out.println("URL image: "+	getUrlImage().getSize());
			 
			 File someFile = File.createTempFile("tempfileAccessory", ".tmp"); 
			 if(!someFile.exists()) {
				 someFile.createNewFile();
			 }
		        FileOutputStream fos = new FileOutputStream(someFile);
		        fos.write(getUrlImage().getContents());
		        fos.flush();
		        fos.close();
			    
			    
		        accessoryJPA.setImage(getUrlImage().getContents());
		}
		
		modifyAccesoryRemote.modifyAccessory(accessoryJPA);
		
		dataAccesory = new AccessoryJPA();
		setIdCategory(0);
		
		
		return "AccessoryListView";
		
	}
	

	public String deleteAccessory() throws Exception {	
		
		System.out.print("Entra para eliminar un accesorio:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyAccesoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AccessoryJPA accessoryJPA = new AccessoryJPA();
		accessoryJPA = modifyAccesoryRemote.showAccessory(getIdCategory());
		
		Collection<OrderJPA> lstorderProduct =  modifyAccesoryRemote.listOrdersByProduct(accessoryJPA.getId());
		
		if(lstorderProduct == null || lstorderProduct.size() == 0 ) {
		
			System.out.print("Accesorio encontrado:"+accessoryJPA.getName()+": id:"+accessoryJPA.getId());
			modifyAccesoryRemote.removeAccesory(accessoryJPA);
			System.out.print("Ha eliminado el acuario con id:"+getIdCategory());
			
			 FacesMessage message = new FacesMessage("NHa eliminado el pez extico con id:"+getIdCategory());
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Informacion",message);
		
		} else {
			 FacesMessage message = new FacesMessage("No se puede eliminar el accesorio: "+ accessoryJPA.getName() + " "
				  		+ " ya que  existen usuarios con pedidos pendientes. Por favor, regularize en BD el pedido.");
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Error duplicado",message);
			
		}
		
		
		
		dataAccesory = new AccessoryJPA();
		setIdCategory(0);
		
		return "AccessoryListView";
	}
	
public String orderAccessory() throws Exception {	
		
		System.out.print("Entra para realizar un pedido de un acuario:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyAccesoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AccessoryJPA accessoryJPA = new AccessoryJPA();
		UserRegisteredJPA userAdminJPA;
		
		accessoryJPA = modifyAccesoryRemote.showAccessory(getIdCategory());
		userAdminJPA = (UserRegisteredJPA) modifyAccesoryRemote.showUserByLogin(loginUser);
		
		OrderJPA orderJPA = new OrderJPA();
		
		orderJPA.setFechaPedido(new Date());
		orderJPA.setFechaEntrega(new Date());
		orderJPA.setUserJPA(userAdminJPA);
		orderJPA.setAccessoryJPA(accessoryJPA);
		
		System.out.print("Acuarioencontrado:"+accessoryJPA.getName()+": id:"+accessoryJPA.getId());
		modifyAccesoryRemote.addOrderToUser(orderJPA);
		
		System.out.print("Ha realizado un pedido del acuario con id:"+getIdCategory());
		
		 FacesMessage message = new FacesMessage("Ha realizado el pedido del accesorio::"+accessoryJPA.getName());
         FacesContext context = FacesContext.getCurrentInstance();
         context.addMessage("Informacion",message);
         
		dataAccesory = new AccessoryJPA();
		setIdCategory(0);
		
		return "AccessoryListView";
	}
	
	
	
}
