/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ModifyAquarium;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Aquarium.AquariumJPA;
import edu.uoc.eAquarium.integration.Order.OrderJPA;
import edu.uoc.eAquarium.integration.User.UserRegisteredJPA;


/**
 * Managed Bean modifyCategoryAgenda
 */
@ManagedBean(name = "modifyAquarium")
@SessionScoped
public class ModifyAquariumMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote modifyCategoryRemote;
	//stores CategoryAgendaJPA instance
	
	protected AquariumJPA dataAquarium;
	//stores CategoryAgendaJPA instance
	protected AquariumJPA dataAquariumInsert;
	
	protected long idCategory = 0;
	
	protected String loginUser = "";
	
	private UploadedFile urlImage;
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		return urlImage;
	}
	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}

	
	public ModifyAquariumMBean() {
		super();
		dataAquarium = new AquariumJPA();
	
	}
	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		
		if(dataAquarium != null && idCategory != 0) {
			setDataAquarium();
		}  
		System.out.println("idCategory aquarium:"+ idCategory);
		
	}
	
	
	
	/**
	 * @return the loginUser
	 */
	public String getLoginUser() {
		return loginUser;
	}
	/**
	 * @param loginUser the loginUser to set
	 */
	public void setLoginUser(String loginUser) {
		this.loginUser = loginUser;
	}
	/**
	 * @return the dataAquariumInsert
	 */
	public AquariumJPA getDataAquariumInsert() {
		return dataAquariumInsert;
	}
	/**
	 * @param dataAquariumInsert the dataCategoryInsert to set
	 */
	public void setDataCategoryInsert(AquariumJPA dataAquariumInsert) {
		this.dataAquariumInsert = dataAquariumInsert;
	}
	public AquariumJPA getDataAquarium() {
		return dataAquarium;
	}	
	
	public void setDataAquarium() throws Exception {
		
		
			Properties props = System.getProperties();
			Context ctx = new InitialContext(props);
			modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
			dataAquarium = (AquariumJPA) modifyCategoryRemote.showAquarium(idCategory);
			System.out.println("Entra en setDataCategory de acuarios con idAcuario:"+idCategory);
			
			System.out.println("Nombre modificado:" +dataAquarium.getName());
			System.out.println("Descripcion:"+dataAquarium.getDescription());
			System.out.println("Alto:"+dataAquarium.getDimensionAlt());
			System.out.println("Ancho:"+dataAquarium.getDimensionAncho());
			System.out.println("Largo:"+dataAquarium.getDimensionLargo());
			System.out.println("Precio:"+dataAquarium.getPrecio());
			
		
		
	}
	
	/**
	 * Get/set the id number and AquariumJPA instance
	 * @return AquariumJPA Id
	 */
	public long getIdCategory()
	{
		System.out.println("Entra acuarios :"+ idCategory);
		return idCategory;
	}

	public String volver() throws Exception {
		dataAquarium = new AquariumJPA();
		setIdCategory(0);
		return "AquariumListView";
	}
 
	/**
	 * Method that gets a list of instances by category or all AquariumJPA
	 * @throws Exception
	 */

	@SuppressWarnings("unused")
	public String modifyAquarium() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AquariumJPA aquariumJPA = new AquariumJPA();
		aquariumJPA.setId(dataAquarium.getId());
		aquariumJPA.setName(dataAquarium.getName());
		aquariumJPA.setDescription(dataAquarium.getDescription());
		aquariumJPA.setDimensionAlt(dataAquarium.getDimensionAlt());
		aquariumJPA.setDimensionAncho(dataAquarium.getDimensionAncho());
		aquariumJPA.setDimensionLargo(dataAquarium.getDimensionLargo());
		aquariumJPA.setPrecio(dataAquarium.getPrecio());
		
		if(urlImage != null) {
			System.out.println("URL image: "+	getUrlImage().getFileName());
			System.out.println("Tipo: "+	getUrlImage().getContentType());
			System.out.println("URL image: "+	getUrlImage().getSize());
			 
			 
			File someFile = File.createTempFile("tempfileAquarium", ".tmp"); 
			 if(!someFile.exists()) {
				 someFile.createNewFile();
			 }
		        FileOutputStream fos = new FileOutputStream(someFile);
		        fos.write(getUrlImage().getContents());
		        fos.flush();
		        fos.close();
			    
			    
		        aquariumJPA.setImage(getUrlImage().getContents());
		}
		
		System.out.println("Nombre modificado:" +dataAquarium.getName());
		System.out.println("Descripcion:"+dataAquarium.getDescription());
		System.out.println("Alto:"+dataAquarium.getDimensionAlt());
		System.out.println("Ancho:"+dataAquarium.getDimensionAncho());
		System.out.println("Largo:"+dataAquarium.getDimensionLargo());
		System.out.println("Precio:"+dataAquarium.getPrecio());
		
		modifyCategoryRemote.modifyAquarium(aquariumJPA);
		
		dataAquarium = new AquariumJPA();
		setIdCategory(0);
		
		
		return "AquariumListView";
		
	}
	
	public String deleteAquarium() throws Exception {	
		
		System.out.print("Entra para eliminar un acuario:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AquariumJPA aquariumJPA = new AquariumJPA();
		aquariumJPA = modifyCategoryRemote.showAquarium(getIdCategory());
		
		Collection<OrderJPA> lstorderProduct =  modifyCategoryRemote.listOrdersByProduct(aquariumJPA.getId());
		
		if(lstorderProduct == null || lstorderProduct.size() == 0 ) {
		
		System.out.print("Acuario encontrado:"+aquariumJPA.getName()+": id:"+aquariumJPA.getId());
		modifyCategoryRemote.removeAquarium(aquariumJPA);
		System.out.print("Ha eliminado el acuario con id:"+getIdCategory());
		
		} else {
			 FacesMessage message = new FacesMessage("No se puede eliminar el siguiente acuario: "+ aquariumJPA.getName() + " "
				  		+ " ya que  existen usuarios con pedidos pendientes. Por favor, regularize en BD el pedido.");
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Error duplicado",message);
		}
		dataAquarium = new AquariumJPA();
		setIdCategory(0);
		
		return "AquariumListView";
	}
	
	public String orderExoticFish() throws Exception {	
		
		System.out.print("Entra para realizar un pedido de un acuario:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		AquariumJPA aquariumJPA = new AquariumJPA();
		UserRegisteredJPA userAdminJPA;
		
		aquariumJPA = modifyCategoryRemote.showAquarium(getIdCategory());
		userAdminJPA = (UserRegisteredJPA) modifyCategoryRemote.showUserByLogin(loginUser);
		
		OrderJPA orderJPA = new OrderJPA();
		
		orderJPA.setFechaPedido(new Date());
		orderJPA.setFechaEntrega(new Date());
		orderJPA.setUserJPA(userAdminJPA);
		orderJPA.setAquariumJPA(aquariumJPA);
		
		System.out.print("Acuarioencontrado:"+aquariumJPA.getName()+": id:"+aquariumJPA.getId());
		modifyCategoryRemote.addOrderToUser(orderJPA);
		System.out.print("Ha realizado un pedido del acuario con id:"+getIdCategory());
		
		
		 FacesMessage message = new FacesMessage("Ha realizado el pedido del acuario: "+aquariumJPA.getName());
         FacesContext context = FacesContext.getCurrentInstance();
         context.addMessage("Informacion",message);
		dataAquarium = new AquariumJPA();
		setIdCategory(0);
		
		return "AquariumListView";
	}
	
	
}
