/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ModifyCategory;

import java.io.File;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.Properties;

import javax.ejb.EJB;
import javax.ejb.TransactionAttribute;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.UploadedFile;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;
import edu.uoc.eAquarium.integration.Order.OrderJPA;
import edu.uoc.eAquarium.integration.User.UserRegisteredJPA;

/**
 * Managed Bean modifyCategoryAgenda
 */
@ManagedBean(name = "modifyCategoryAgenda")
@SessionScoped
public class ModifyCategoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote modifyCategoryRemote;
	//stores CategoryAgendaJPA instance
	
	protected ExoticFishJPA dataCategory;
	//stores CategoryAgendaJPA instance
	protected ExoticFishJPA dataCagtegoryInsert;
	
	//stores ExoticFish number id
	protected long idCategory = 0;
	
	//stores ExoticFish number id
	protected String loginUser = "";
	
	private UploadedFile urlImage;
	
	/**
	 * @return the urlImage
	 */
	public UploadedFile getUrlImage() {
		return urlImage;
	}


	/**
	 * @param urlImage the urlImage to set
	 */
	public void setUrlImage(UploadedFile urlImage) {
		if(urlImage != null) {
			this.urlImage = urlImage;
		
			FacesMessage message = new FacesMessage("Se ha cargado la imagen.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		} else {
			FacesMessage message = new FacesMessage("No se ha realizado la carga correctamente.");
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage("Info",message);
		}
	}


	public ModifyCategoryMBean() {
		super();
		dataCategory = new ExoticFishJPA();
	
	}
	
	
	public String getLoginUser() {
		return loginUser;
	}


	public void setLoginUser(String loginUser) {
		this.loginUser = loginUser;
	}


	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		
		if(dataCategory != null && idCategory != 0) {
			setDataCategory();
		}  
		System.out.println("idCategory:"+ idCategory);
		
	}
	
	
	
	/**
	 * @return the dataCagtegoryInsert
	 */
	public ExoticFishJPA getDataCategoryInsert() {
		return dataCagtegoryInsert;
	}
	/**
	 * @param dataCategoryInsert the dataCategoryInsert to set
	 */
	public void setDataCategoryInsert(ExoticFishJPA dataCategoryInsert) {
		this.dataCagtegoryInsert = dataCategoryInsert;
	}
	public ExoticFishJPA getDataCategory() {
		return dataCategory;
	}	
	
	public void setDataCategory() throws Exception {
		
		
			Properties props = System.getProperties();
			Context ctx = new InitialContext(props);
			modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
			dataCategory = (ExoticFishJPA) modifyCategoryRemote.showCategory(idCategory);
			System.out.println("Entra en setDataCategory :"+ dataCategory.getName());
		
		
	}
	
	/**
	 * Get/set the id number and ExoticFishJPA instance
	 * @return ExoticFishJPA Id
	 */
	public long getIdCategory()
	{
		System.out.println("Entra alta :"+ idCategory);
		return idCategory;
	}

	public String volver() throws Exception {
		dataCategory = new ExoticFishJPA();
		setIdCategory(0);
		return "CategoryListView";
	}
 
	/**
	 * Method that gets a list of instances by category or all ExoticFishJPA
	 * @throws Exception
	 */

	@SuppressWarnings("unused")
	@TransactionAttribute
	public String modifyCategory() throws Exception {	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		ExoticFishJPA categoryAgendaJPA = new ExoticFishJPA();
		categoryAgendaJPA.setIdFish(dataCategory.getIdFish());
		categoryAgendaJPA.setName(dataCategory.getName());
		categoryAgendaJPA.setScientificName(dataCategory.getScientificName());
		
		//Guardamos la imagen
	
	
		
	
		if(urlImage != null) {
			System.out.println("URL image: "+	getUrlImage().getFileName());
			System.out.println("Tipo: "+	getUrlImage().getContentType());
			System.out.println("URL image: "+	getUrlImage().getSize());
			 
//			 File someFile = new File("C:\\"+getUrlImage().getFileName());
			 File someFile = File.createTempFile("tempfileCategory", ".tmp"); 
			 if(!someFile.exists()) {
				 someFile.createNewFile();
			 }
		        FileOutputStream fos = new FileOutputStream(someFile);
		        fos.write(getUrlImage().getContents());
		        fos.flush();
		        fos.close();
			    
			    
			categoryAgendaJPA.setImage(getUrlImage().getContents());
		}
		
		categoryAgendaJPA.setPrice(dataCategory.getPrice());
		categoryAgendaJPA.setPlace(dataCategory.getPlace());
		System.out.println("Nombre modificado:" +dataCategory.getName());
		System.out.println("Nombre cientfico:" +dataCategory.getScientificName());
		System.out.println("Nombre precio:" +dataCategory.getPrice());
		System.out.println("Nombre precio:" +dataCategory.getPlace());
		
		modifyCategoryRemote.modifyCategoryAgenda(categoryAgendaJPA);
		
		dataCategory = new ExoticFishJPA();
		setIdCategory(0);
		
		
		return "CategoryListView";
		
	}
	

	public String deleteExoticFish() throws Exception {	
		
		System.out.print("Entra para eliminar un pez extico:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		
		ExoticFishJPA exoticFish = new ExoticFishJPA();
		exoticFish = modifyCategoryRemote.showCategory(getIdCategory());
		System.out.print("PEz extico encontrado:"+exoticFish.getName()+": id:"+exoticFish.getIdFish());

		
		Collection<OrderJPA> lstorderProduct =  modifyCategoryRemote.listOrdersByProduct(exoticFish.getIdFish());
		
		if(lstorderProduct == null || lstorderProduct.size() == 0 ) {
		
			modifyCategoryRemote.removeExoticFish(exoticFish);
			System.out.print("Ha eliminado el pez extico con id:"+getIdCategory());
			 FacesMessage message = new FacesMessage("NHa eliminado el pez extico con id:"+getIdCategory());
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Informacion",message);
		
		} else {
			 FacesMessage message = new FacesMessage("No se puede eliminar el pez extico: "+ exoticFish.getName() + " "
				  		+ " ya que  existen usuarios con pedidos pendientes. Por favor, regularize en BD el pedido.");
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Error duplicado",message);
			
		}
		dataCategory = new ExoticFishJPA();
		setIdCategory(0);
		
		return "CategoryListView";
	}
	
	
	 
	public String orderExoticFish() throws Exception {	
		
		System.out.print("Entra para realizar un pedido de un pez extico:"+getIdCategory());
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
//		screen = 0;
		modifyCategoryRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		ExoticFishJPA exoticFish = new ExoticFishJPA();
		UserRegisteredJPA userAdminJPA;
		
		exoticFish = modifyCategoryRemote.showCategory(getIdCategory());
		userAdminJPA = (UserRegisteredJPA) modifyCategoryRemote.showUserByLogin(loginUser);
		
		OrderJPA orderJPA = new OrderJPA();
		
		orderJPA.setFechaPedido(new Date());
		orderJPA.setFechaEntrega(new Date());
		orderJPA.setUserJPA(userAdminJPA);
		orderJPA.setExoticFishJPA(exoticFish);
		
		System.out.print("PEz extico encontrado:"+exoticFish.getName()+": id:"+exoticFish.getIdFish());
		modifyCategoryRemote.addOrderToUser(orderJPA);
		System.out.print("Ha realizado un pedido del pez extico con id:"+getIdCategory());
		
		 FacesMessage message = new FacesMessage("Ha realizado el pedido del pez extico::"+exoticFish.getName());
         FacesContext context = FacesContext.getCurrentInstance();
         context.addMessage("Informacion",message);
		
		dataCategory = new ExoticFishJPA();
		setIdCategory(0);
		
		return "CategoryListView";
	}
	
}
