package edu.uoc.eAquarium.presentation.action.ShowAccessory;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.DefaultStreamedContent;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;

/**
 * Managed Bean ShowAccessoryMBean
 */
@ManagedBean(name = "showAccessory")
@SessionScoped
public class ShowAccessoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote accessoryFacadeRemote;

	protected AccessoryJPA dataAccessory;
	protected long idCategory = 1;
	private DefaultStreamedContent imagen;
	
	public ShowAccessoryMBean() throws Exception 
	{
		setDataAccessory();
	}
	
	
	
	/**
	 * @return the imagen
	 */
	public DefaultStreamedContent getImagen() {
		return imagen;
	}



	/**
	 * @param imagen the imagen to set
	 */
	public void setImagen(DefaultStreamedContent imagen) {
		this.imagen = imagen;
	}



	/**
	 * Get/set the id number and AccessoryJPA instance
	 * @return AccessoryJPA Id
	 */
	public long getIdCategory()
	{
		return idCategory;
	}
	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		setDataAccessory();
		System.out.println("idshowAccessory:"+ idCategory);
	}
	public AccessoryJPA getDataAccessory()
	{
		return dataAccessory;
	}	
	public void setDataAccessory() throws Exception
	{	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		accessoryFacadeRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		System.out.print("Busca el accesorio con ID:"+idCategory);
		dataAccessory = (AccessoryJPA) accessoryFacadeRemote.showAccessory(idCategory);
		
		try {
			
			if(dataAccessory.getImage() != null && dataAccessory.getImage().length > 0 ) {
					System.out.print("Pez: "+ dataAccessory.getName());
					System.out.print("Pez2: "+ dataAccessory.getImage().length);
					
					File someFile = File.createTempFile("tempfileAccessory", ".tmp"); 
					someFile.createNewFile();
			        FileOutputStream fos = new FileOutputStream(someFile);
			        fos.write(dataAccessory.getImage());
			        fos.flush();
			        fos.close();
			        
			        System.out.print("Tamano:"+dataAccessory.getImage().length);
			        InputStream input = new FileInputStream(someFile);  
			        imagen = new DefaultStreamedContent(input, "image/jpg");
			} else {
				imagen = null;
			}
		}catch (Exception e) {
			System.out.print("ERROR:"+e.getMessage());
		}
	}
}
