/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ShowCategory;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.DefaultStreamedContent;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;

/**
 * Managed Bean ShowExoticFishMBean
 */
@ManagedBean(name = "showCategory")
@SessionScoped
public class ShowCategoryMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote showPetRemote;
	//stores ExoticFishJPA instance
	protected ExoticFishJPA dataCategory;
	//stores ExoticFishJPA number id
	protected long idCategory = 1;
	
	private DefaultStreamedContent imagen;
	
	
	public ShowCategoryMBean() throws Exception 
	{
		setDataCategory();
	}
	
	
	
	/**
	 * @return the imagen
	 */
	public DefaultStreamedContent getImagen() {
		return imagen;
	}



	/**
	 * @param imagen the imagen to set
	 */
	public void setImagen(DefaultStreamedContent imagen) {
		this.imagen = imagen;
	}



	/**
	 * Get/set the id number and ExoticFishJPA instance
	 * @return ExoticFish Id
	 */
	public long getIdCategory()
	{
		return idCategory;
	}
	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		setDataCategory();
		System.out.println("idshowCategory:"+ idCategory);
	}
	public ExoticFishJPA getDataCategory()
	{
		return dataCategory;
	}	
	public void setDataCategory() throws Exception
	{	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		showPetRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		
		dataCategory = (ExoticFishJPA) showPetRemote.showCategory(idCategory);
		try {
				System.out.print("Pez: "+ dataCategory.getName());
				
				if(dataCategory.getImage() != null && dataCategory.getImage().length > 0 ) {
				
				System.out.print("Pez2: "+ dataCategory.getImage().length);
				
			    File someFile = File.createTempFile("tempfileCategory", ".tmp"); 
			 someFile.createNewFile();
		        FileOutputStream fos = new FileOutputStream(someFile);
		        fos.write(dataCategory.getImage());
		        fos.flush();
		        fos.close();
		        
		        System.out.print("Tamano:"+dataCategory.getImage().length);
		      InputStream input = new FileInputStream(someFile);  
			imagen = new DefaultStreamedContent(input, "image/jpg");
			} else {
				imagen = null;
			}
			
		}catch (Exception e) {
			System.out.print("ERROR en categoria: "+e.getMessage());
		}
//		
		
	}
}
