/*
 * Copyright FUOC.  All rights reserved.
 * @author Vicen Font Sagrist, 2012
 */
package edu.uoc.eAquarium.presentation.action.ShowUser;

import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.naming.Context;
import javax.naming.InitialContext;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Accessory.AccessoryJPA;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;
import edu.uoc.eAquarium.integration.User.UserJPA;

/**
 * Managed Bean ShowUserMBean
 */
@ManagedBean(name = "showUser")
@SessionScoped
public class ShowUserMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote showUserRemote;
	//stores UserJPA instance
	protected UserJPA dataUser;
	//stores UserJPA number id
	private String login = "";
	private String password = "";
	
	public ShowUserMBean() throws Exception 
	{
		super();
		
		setDataUser();
		
	}
	
	
	public String getPassword() {
		return password;
	}


	public void setPassword(String password) {
		System.out.println("password:"+ password);
		this.password = password;
	}


	public String getLogin()
	{
		return login;
	}
	
	public void setLogin(String login) throws Exception
	{
		this.login = login;
//		setDataCategory();
		System.out.println("login:"+ login);
	}
	public UserJPA getDataUser()
	{
		return dataUser;
	}	
	public void setDataUser() throws Exception
	{	
		System.out.print("Carga el contexto facade");
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		showUserRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		System.out.print("Finaliza la carga del facade para usuario correctamente.");
	}
	
	public String findUser() throws Exception
	{	
		
		System.out.print("Busca usuario... \n");
		 FacesMessage message;
		dataUser = (UserJPA) showUserRemote.showUser(login, password);
		 if (dataUser == null ) {
			  message = new FacesMessage("Usuario con login :"+ getLogin() + " no encontrado.\n");
		            FacesContext context = FacesContext.getCurrentInstance();
		            context.addMessage("Not Found",message);
			 System.out.print("Usuario con login :"+ getLogin() + " no encontrado.\n");

		 } else {
			
			 System.out.print("Usuario encontrado:"+ dataUser.getLogin() + ": Perfil:"+ dataUser.getPerfil().getId());
		 }
	
		 return "homeView";
	}
	
	
	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String logOut() throws Exception {
		
		this.dataUser = null;
		return "homeView";
	
	}
	
	/**
	 * Method used for Facelet to call CategoryListView Facelet
	 * @return Facelet name
	 * @throws Exception
	 */
	public String showAddUser() throws Exception {
		
		
		return "AddUserView";
	
	}
}
