package edu.uoc.eAquarium.presentation.action.showAquarium;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.Serializable;
import java.util.Properties;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.primefaces.model.DefaultStreamedContent;

import edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote;
import edu.uoc.eAquarium.integration.Aquarium.AquariumJPA;
import edu.uoc.eAquarium.integration.ExoticFish.ExoticFishJPA;

/**
 * Managed Bean ShowAquariumMBean
 */
@ManagedBean(name = "showAquarium")
@SessionScoped
public class ShowAquariumMBean implements Serializable{
	
	private static final long serialVersionUID = 1L;

	@EJB
	private CategoryFacadeRemote categoryFacadeRemote;
	//stores AquariumJPA instance
	protected AquariumJPA dataAquarium;
	//stores AquariumJPA number id
	protected long idCategory = 1;
	
	private DefaultStreamedContent imagen;
	
	public ShowAquariumMBean() throws Exception 
	{
		setDataAquarium();
	}
	
	/**
	 * @return the imagen
	 */
	public DefaultStreamedContent getImagen() {
		return imagen;
	}



	/**
	 * @param imagen the imagen to set
	 */
	public void setImagen(DefaultStreamedContent imagen) {
		this.imagen = imagen;
	}
	
	/**
	 * Get/set the id number and AquariumJPA instance
	 * @return Aquarium Id
	 */
	public long getIdCategory()
	{
		return idCategory;
	}
	public void setIdCategory(long idCategory) throws Exception
	{
		this.idCategory = idCategory;
		setDataAquarium();
		System.out.println("idshowCategory:"+ idCategory);
	}
	public AquariumJPA getDataAquarium()
	{
		return dataAquarium;
	}	
	public void setDataAquarium() throws Exception
	{	
		Properties props = System.getProperties();
		Context ctx = new InitialContext(props);
		categoryFacadeRemote = (CategoryFacadeRemote) ctx.lookup("java:app/GestAquarium.jar/CategoryFacade!edu.uoc.eAquarium.bussines.interfaces.CategoryFacadeRemote");
		System.out.print("Busca el acuario con ID:"+idCategory);
		dataAquarium = (AquariumJPA) categoryFacadeRemote.showAquarium(idCategory);
		
		try {
			
			if(dataAquarium.getImage() != null && dataAquarium.getImage().length > 0 ) {
					System.out.print("Acuario: "+ dataAquarium.getName());
					System.out.print("Tamao acuario: "+ dataAquarium.getImage().length);
					
				 
					File someFile = File.createTempFile("tempfileAquarium", ".tmp"); 
					someFile.createNewFile();
			        FileOutputStream fos = new FileOutputStream(someFile);
			        fos.write(dataAquarium.getImage());
			        fos.flush();
			        fos.close();
			        
			        System.out.print("Tamano:"+dataAquarium.getImage().length);
			        InputStream input = new FileInputStream(someFile);  
			        imagen = new DefaultStreamedContent(input, "image/jpg");
			} else{
				imagen = null;
			}
		}catch (Exception e) {
			System.out.print("ERROR:"+e.getMessage());
		}
	}
}
